<script lang="ts">
  import { onMount } from 'svelte';
  import PageHeader from '$lib/components/layout/PageHeader.svelte';
  import ScheduleItem from '$lib/components/ui-elements/ScheduleItem.svelte';
  import _ from 'lodash';
  import { faInfoCircle } from '@fortawesome/free-solid-svg-icons';
  import type { GroupedEventsByMonth } from '$lib/interfaces/schedule';
  import type { EventSchedule$result } from '$houdini';
  import { EventScheduleStore } from '$houdini';
  import Fa from 'svelte-fa';

  /*
   * There are 3 places that the year is hard-coded and must be updated:
   * - The banner of the page
   * - Each month's header
   * - The query in page.gql
   */

  const monthNames = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'June', 'July', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'] as const;
  type ExtendedEventResult = EventSchedule$result & { start?: Date; id: string; name: string };

  let events: Partial<EventSchedule$result>[] = [];
  const Events = new EventScheduleStore();

  $: {
    console.log($Events);
    if ($Events?.data) {
      console.log($Events);
      events = $Events.data.events as Partial<EventSchedule$result>[];
    }
  }

  onMount(() => Events.fetch());

  function GroupEvents(data: Partial<EventSchedule$result>[]) {
    data.sort(function (a, b) {
      // @ts-ignore: date math is apparently fine here
      return a.start - b.start;
    });

    console.log(data);

    // Group by month and store in tmp var
    const tmp = _.groupBy<EventSchedule$result>(data as EventSchedule$result[], (event) =>
      'start' in event && event.start instanceof Date ? `${monthNames[(event.start as Date).getMonth()]}` : ''
    );
    const grouped: GroupedEventsByMonth = {};

    for (const group in tmp) {
      // @ts-ignore typing in this file is a disaster but it works, someone plz fix
      grouped[group] = _.groupBy<ExtendedEventResult>(tmp[group] as ExtendedEventResult[], (event) =>
        event.start ? event.start.getDate() : null
      );
    }

    console.log(grouped);
    return grouped;
  }

  // let events = GroupEvents(Events.data.events);
</script>

<PageHeader title="Schedule" />

{#if $Events.fetching || $Events.data == null}
  <p>loading...</p>
{:else}
  <section class="text-cyber-blue-900 text-center flex justify-center px-5 2xl:px-72 pb-16 ">
    <div class="w-full">
      <div role="alert" class="pt-5 mb-12">
        <div class="bg-blue-400 text-white font-bold rounded-t px-4 py-2 ">
          <Fa class="inline-block" icon={faInfoCircle} />
          Registration Information
        </div>
        <div class="border border-t-0 border-blue-400 rounded-b bg-blue-100 px-4 py-3">
          Please note that registration ends <b>4 days</b> before the scheduled event date, and team rosters must be
          finalized <b>2 days</b> before the event. Participants must be actively attending an
          <a href="https://www.caecommunity.org/cae-map" target="_blank">NCAE-C School</a>. For more details, please see
          the
          <a href="/rules">Rules Page</a>
        </div>
      </div>
      {#each Object.entries(GroupEvents(events)) as [key, value] (key)}
        <div class="relative flex pt-5 items-center">
          <span class="flex-shrink text-2xl text-gray-500 px-4 italic font-light">{key} 2025</span>
          <div class="flex-grow border-t border-gray-400" />
        </div>
        <ScheduleItem events={value} />
      {/each}
    </div>
  </section>
{/if}
